    SUBROUTINE CleanString(String,CleanStr)
! This subroutine cleans a string, that is: it removes some characters
! from it that are in CleanString input variable

!----------------------------------------------------------------------
!  Copyright 2003-2014 Ecole Normale Supérieure de Lyon, 
!  Centre National de la Recherche Scientifique,
!  Université Claude Bernard Lyon 1. All rights reserved.
!
!  This work is registered with the Agency for the Protection of Programs 
!  as IDDN.FR.001.100009.000.S.P.2014.000.30625
!
!  Authors: P. Fleurat-Lessard, P. Dayal
!  Contact: optnpath@gmail.com
!
! This file is part of "Opt'n Path".
!
!  "Opt'n Path" is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Affero General Public License as
!  published by the Free Software Foundation, either version 3 of the License,
!  or (at your option) any later version.
!
!  "Opt'n Path" is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Affero General Public License for more details.
!
!  You should have received a copy of the GNU Affero General Public License
!  along with "Opt'n Path". If not, see <http://www.gnu.org/licenses/>.
!
! Contact The Office of Technology Licensing, valorisation@ens-lyon.fr,
! for commercial licensing opportunities.
!----------------------------------------------------------------------

      Use VarTypes

      IMPLICIT NONE

! Input Variables
      CHARACTER(*), INTENT(INOUT) :: String
      CHARACTER(*), INTENT(IN) :: CleanStr

      INTEGER(KINT) :: I
      LOGICAL :: Debug

  INTERFACE
     function valid(string) result (isValid)
       CHARACTER(*), intent(in) :: string
       logical                  :: isValid
     END function VALID

  end INTERFACE
  

      Debug=Valid("CleanString")
      
      if (debug) Call header("Entering CleanString")
         
      if (debug) THEN
         WRITE(*,*) "String:",String,"*END*"
         WRITE(*,*) "CleanStr:",CleanStr,"*END*"
      END IF

      I=Scan(TRIM(String),CleanStr)
      DO WHILE ((I/=0).AND.(I<=LEN(TRIM(String))))
         String=String(1:I-1) // String (I+1:)
         I=Scan(String,CleanStr)
         if (debug) THEN
            WRITE(*,*) "String:",String,"*END*",I,Len(TRIM(String))
            WRITE(*,*) "TRIMString:",TRIM(String),"*END*"
         END IF

      END DO

      if (debug) THEN
         WRITE(*,*) "String:",String,"*END*"
      END IF

      if (debug) Call header("Exiting CleanString")

    END SUBROUTINE CleanString
